package eu.unicore.gateway.base;

import java.security.cert.X509Certificate;

/**
 * 
 * An interface to validate X509 RFC 3820 Proxy Certificates. 
 * The implementations realize the validation algorithms.  
 * See {@link http://www.ietf.org/rfc/rfc3820.txt} for more details. 
 * 
 * @author shahbaz memon, shiraz memon
 */
public interface IProxyCertificateValidator {
	public void validate(X509Certificate[] certPath,
			X509Certificate[] trustedCerts) throws Exception;
}
