package eu.unicore.gateway;

import java.net.URI;

import eu.unicore.gateway.VSite;
import junit.framework.TestCase;

public class TestVsite extends TestCase {

	public void test1()throws Exception{
		VSite v0 = new VSite(new URI("http://localhost:8080"),
			"test", "http://localhost:1234", null);
		assertTrue(v0.accept("http://localhost:8080/test/bar"));
		
		String address="http://localhost:8080/test/index.html";
		System.out.println(v0.resolve(address));
		assertEquals("http://localhost:1234/index.html",v0.resolve(address));
		
		
		address="http://localhost:8080/test/index.html?res=xxx";
		System.out.println(v0.resolve(address));
		assertEquals("http://localhost:1234/index.html?res=xxx",v0.resolve(address));
		
		
		VSite v1=new VSite(new URI("http://localhost/foo"),"test",
			"http://localhost:1234", null);
		assertTrue(v1.accept("http://localhost/foo/test/bar"));
		assertEquals("http://localhost:1234/index.html",v0.resolve("http://localhost/foo/test/index.html"));
	
	}
	
	public void testVSiteEquals()throws Exception{
		URI gw=new URI("http://localhost");
		Site s1=new VSite(gw,"FOO","http://localhost:1234", null);
		Site s2=new VSite(gw,"FOO","http://localhost:1234", null);
		assertEquals(s1,s2);
	}
	
	public void testVSiteNotEquals()throws Exception{
		URI gw=new URI("http://localhost");
		Site s1=new VSite(gw,"FOO","http://localhost:3456", null);
		Site s2=new VSite(gw,"FOO2","http://localhost:3456", null);
		assertNotSame(s1,s2);
	}

	
}
