package eu.unicore.gateway.base;

import java.io.File;
import java.security.KeyStore;
import java.security.cert.X509Certificate;
import java.util.Enumeration;

import junit.framework.TestCase;
import eu.unicore.gateway.properties.GatewayProperties;

public class TestReadCerts extends TestCase {

	public void testReadFromFile()throws Exception{
		GatewayProperties p=new GatewayProperties(new File("src/test/resources/gateway.properties"));
		CustomSslSocketConnector ssl=new CustomSslSocketConnector(p);
		ssl.setTruststore("src/test/resources/certs/twocerts.pem");
		ssl.setTruststoreType("file");
		KeyStore ks=ssl.loadTruststore();
		assertNotNull(ks);
		Enumeration<String>i=ks.aliases();
		while(i.hasMoreElements()){
			String alias=i.nextElement();
			X509Certificate c=(X509Certificate)ks.getCertificate(alias);
			assertNotNull(c);
			System.out.println(alias+" : "+c.getSubjectDN().getName());
		}
	}
	public void testReadFromDir()throws Exception{
		GatewayProperties p=new GatewayProperties(new File("src/test/resources/gateway.properties"));
		CustomSslSocketConnector ssl=new CustomSslSocketConnector(p);
		ssl.setTruststore("src/test/resources/certs");
		ssl.setTruststoreType("directory");
		KeyStore ks=ssl.loadTruststore();
		assertNotNull(ks);
		Enumeration<String>i=ks.aliases();
		while(i.hasMoreElements()){
			String alias=i.nextElement();
			X509Certificate c=(X509Certificate)ks.getCertificate(alias);
			assertNotNull(c);
		}
	}
	
	public void testReadFromDirNoType()throws Exception{
		GatewayProperties p=new GatewayProperties(new File("src/test/resources/gateway.properties"));
		CustomSslSocketConnector ssl=new CustomSslSocketConnector(p);
		ssl.setTruststore("src/test/resources/certs");
		KeyStore ks=ssl.loadTruststore();
		assertNotNull(ks);
		Enumeration<String>i=ks.aliases();
		while(i.hasMoreElements()){
			String alias=i.nextElement();
			X509Certificate c=(X509Certificate)ks.getCertificate(alias);
			assertNotNull(c);
		}
	}
}
